'rapidq basic - lpt tester
$Typecheck On

$Resource InpOut32 As "inpout32.dll"
$Resource LptPort As "lptport.bmp"

$Option Icon "Icon.ico"

$Include "Rapidq.inc"
$Include "QLed.inc"
$Include "QIniFile.inc"

Defint Port,Bit,DataBit,ControlBit,StatusBit
Dim Ini As QIniFile
Ini.IniPath = "LPT.ini"
Ini.CreateFile

Declare Function INP32 Lib "INPOUT32.DLL" Alias "Inp32" (Address As Integer) As Integer
Declare Sub OUT32 Lib "INPOUT32.DLL" Alias "Out32" (Address As Integer, Bit As Integer)
 
Declare Sub SetPortAddress(Sender As QMenuItem)
Declare Sub LedData(Sender As QCanvas)
Declare Sub LedControl(Sender As QCanvas)
Declare Sub SetData
Declare Sub SetControl
Declare Sub SetLeds
Declare Sub ShowHelp
Declare Sub ShowSettings
Declare Sub ShowAbout
Declare Sub Time
Declare Sub ShowPinInfo(Sender As QCanvas,Dbt As Integer)

Declare Sub FormClose(Action AS INTEGER)
Declare Sub LPTShow(Sender as QForm)
Create LPT As QForm
      Caption = "  LPT Monitor"
      Top     = 253
      Left    = 350
      Width   = 244
      Height  = 129
      BorderStyle = bsToolWindow
      OnShow = LPTShow
      OnClose = FormClose
End Create
Create GroupBoxLPT as QGroupBox
      Parent  = LPT
      Top     = 0
      Left    = 8
      Width   = 221
      Height  = 50
      Caption = ""
      Color   = -2147483633
End Create
Create Led_D0 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 184
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 1
      OnClick  = LedData
      Size = 11
      Hint = "Data0 - Pin1"
      ShowHint = True
End Create
Create Led_D1 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 168
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 2
      OnClick  = LedData
      Size = 11
      Hint = "Data1 - Pin2"
      ShowHint = True
End Create
Create Led_D2 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 152
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 4
      OnClick  = LedData
      Size = 11
      Hint = "Data2 - Pin3"
      ShowHint = True
End Create
Create Led_D3 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 136
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 8
      OnClick  = LedData
      Size = 11
      Hint = "Data3 - Pin4"
      ShowHint = True
End Create
Create Led_D4 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 120
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 16
      OnClick  = LedData
      Size = 11
      Hint = "Data4 - Pin5"
      ShowHint = True
End Create
Create Led_D5 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 104
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 32
      OnClick  = LedData
      Size = 11
      Hint = "Data5 - Pin6"
      ShowHint = True
End Create
Create Led_D6 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 88
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 64
      OnClick  = LedData
      Size = 11
      Hint = "Data6 - Pin7"
      ShowHint = True
End Create
Create Led_D7 As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 72
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 128
      OnClick  = LedData
      Size = 11
      Hint = "Data7 - Pin8"
      ShowHint = True
End Create
Create Led_Strobe As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 200
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Tag      = 1
      OnClick  = LedControl
      Size = 11
      Hint = "Strobe - Pin1"
      ShowHint = True
End Create
Create Led_AutoFeed As QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 193
      Width   = 11
      Height  = 11
      OnClick  = LedControl
      LedColor = ldGreen
      Tag = 2
      Size = 11
      Hint = "AutoFeed - Pin14"
      ShowHint = True
End Create
Create Led_Error As QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 177
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      Hint = "Error - Pin15"
      ShowHint = True
End Create
Create Led_ResetInit As QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 161
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      Hint = "Reset/Init - Pin16"
      ShowHint = True
End Create
Create Led_Select As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 8
      Width   = 14
      Height  = 14
      LedColor = ldGreen
      Size = 11
      Hint = "Select - Pin13"
      ShowHint = True
End Create
Create Led_PaperEmpty As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 24
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      Hint = "PaperEmpty - Pin12"
      ShowHint = True
End Create
Create Led_Acknowledge As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 56
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      Hint = "Acknowledge - Pin10"
      ShowHint = True
End Create
Create Led_Busy As QLed
      Parent  = GroupBoxLPT
      Top     = 16
      Left    = 40
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      Hint = "Busy - Pin11"
      ShowHint = True
End Create
Create Led_SelectInput as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 145
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      Hint = "Select Input - Pin17"
      ShowHint = True
End Create
Create Led2 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 129
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      Hint = "GND - Pin18"
      ShowHint = True
End Create
Create Led3 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 113
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      ShowHint = True
      Hint = "GND - Pin19"
End Create
Create Led4 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 97
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      ShowHint = True
      Hint = "GND - Pin20"
End Create
Create Led5 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 81
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      ShowHint = True
      Hint = "GND - Pin21"
End Create
Create Led6 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 65
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      ShowHint = True
      Hint = "GND - Pin22"
End Create
Create Led7 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 49
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      ShowHint = True
      Hint = "GND - Pin23"
End Create
Create Led8 as QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 33
      Width   = 11
      Height  = 11
      Size = 11
      LedColor = ldGreen
      ShowHint = True
      Hint = "GND - Pin24"
End Create
Create Led9 As QLed
      Parent  = GroupBoxLPT
      Top     = 30
      Left    = 17
      Width   = 11
      Height  = 11
      LedColor = ldGreen
      Size = 11
      ShowHint = True
      Hint = "GND - Pin25"
End Create
Create TTime As QTimer
     Enabled = 0
     Interval = 400
     OnTimer = Time
End Create
Create LabelIN as QLabel
      Parent  = LPT
      Top     = 56
      Left    = 11
      Width   = 213
      Height  = 13
      Caption = ""
      Color   = &HD8E9EC
      AutoSize = False
End Create

$Include "Help.inc"
$Include "Menus.inc"
$Include "Settings.inc"
$Include "Minimize.inc"

SetMinimize(LPT)
LPT.ShowModal

Sub SetPortAddress(Sender As QMenuItem)
Sender.Checked = 1
Port = Sender.Tag
SetLeds
End Sub

Sub LedData(Sender As QCanvas)
    DataBit = Sender.Tag
    SetData
    ShowPinInfo(Sender,DataBit)
End Sub

Sub LedControl(Sender As QCanvas)
    ControlBit = Sender.Tag
    SetControl
    ShowPinInfo(Sender,ControlBit)
End Sub

Sub SetControl
  Bit = INP32(Port + 2)
  OUT32 Port + 2, Bit Xor ControlBit
  SetLEDs
End Sub

Sub SetData
  Bit = INP32(Port)
  OUT32 Port, Bit Xor DataBit
  SetLEDs
End Sub

Sub Time
SetLeds
End Sub

Sub SetLEDs
  Bit = INP32(Port)
  If Bit And 1   Then: Led_D0.LedState = ldOn: Else: Led_D0.LedState = ldOff: End If
  If Bit And 2   Then: Led_D1.LedState = ldOn: Else: Led_D1.LedState = ldOff: End If
  If Bit And 4   Then: Led_D2.LedState = ldOn: Else: Led_D2.LedState = ldOff: End If
  If Bit And 8   Then: Led_D3.LedState = ldOn: Else: Led_D3.LedState = ldOff: End If
  If Bit And 16  Then: Led_D4.LedState = ldOn: Else: Led_D4.LedState = ldOff: End If
  If Bit And 32  Then: Led_D5.LedState = ldOn: Else: Led_D5.LedState = ldOff: End If
  If Bit And 64  Then: Led_D6.LedState = ldOn: Else: Led_D6.LedState = ldOff: End If
  If Bit And 128 Then: Led_D7.LedState = ldOn: Else: Led_D7.LedState = ldOff: End If

  Bit = INP32(Port + 2)
  If Bit And 1 Then: Led_Strobe.LedState    = ldOff: Else: Led_Strobe.LedState    = ldOn:  End If
  If Bit And 2 Then: Led_AutoFeed.LedState  = ldOff: Else: Led_AutoFeed.LedState  = ldOn:  End If
  If Bit And 4 Then: Led_ResetInit.LedState = ldOn:  Else: Led_ResetInit.LedState = ldOff: End If
  If Bit And 8 Then: Led_Error.LedState     = ldOn:  Else: Led_Error.LedState     = ldOff: End If

  Bit = INP32(Port + 1)
  If Bit And 8 Then:   Led_ResetInit.LedState   = ldOn:  Else: Led_ResetInit.LedState   = ldOff: End If
  If Bit And 16 Then:  Led_Select.LedState      = ldOn:  Else: Led_Select.LedState      = ldOff: End If
  If Bit And 32 Then:  Led_PaperEmpty.LedState  = ldOn:  Else: Led_PaperEmpty.LedState  = ldOff: End If
  If Bit And 64 Then:  Led_Acknowledge.LedState = ldOn:  Else: Led_Acknowledge.LedState = ldOff: End If
  If Bit And 128 Then: Led_Busy.LedState        = ldOff: Else: Led_Busy.LedState        = ldOn:  End If
End Sub

Sub ShowPinInfo
LabelIN.Caption = Sender.Hint + " [ " + Str$(Port) + " : " + Str$(Dbt) + " ]"
End Sub

Sub ShowHelp
Help.ShowModal
End Sub

Sub ShowSettings
Settings.ShowModal
End Sub

Sub ShowAbout
MessageDlg "LPT Monitor V0.99" + Chr$(10) + _
           "Written in Rapidq by Nastase Eodor 2005" + Chr$(10) + _
           "eodor@3x.ro - http://eodor.3x.ro" + Chr$(10) + _
           "[RqWork]",mtInformation,mbok,0
End Sub

Sub FormClose(Action AS INTEGER)
Ini.WriteInteger("Settings","Top",LPT.Top,1)
Ini.WriteInteger("Settings","Left",LPT.Left,1)
Ini.WriteInteger("Settings","Read-Write",CheckBoxRW.Checked,1)
Ini.WriteInteger("Settings","StayOnTop",CheckBoxST.Checked,1)
Ini.WriteInteger("Settings","RateSample",RateBox.ItemIndex,1)
Application.Terminate
End Sub
 
Sub LPTShow(Sender as QForm)
If FileExists("Inpout32.dll") = 0 then
   ExtractResource(Resource(0),"Inpout32.dll")
End If
SetPortAddress(MI378)
LPT.Top  = Ini.ReadInteger("Settings","Top")
LPT.Left = Ini.ReadInteger("Settings","Left")
CheckBoxRW.Checked = Ini.ReadInteger("Settings","Read-Write")
CheckBoxST.Checked = Ini.ReadInteger("Settings","StayOnTop")
RateBox.ItemIndex  = Ini.ReadInteger("Settings","RateSample")
CheckBoxRWClick(CheckBoxRW)
CheckBoxSTClick(CheckBoxST)
RateBoxChange(RateBox)
End Sub
